//
// Created by nouri on 02.09.22.
//

#ifndef HELIOS_BASE_ENERGYSTORE_H
#define HELIOS_BASE_ENERGYSTORE_H

/*! \file
 *  EnergyStore.cpp
 *  EnergyStore.h
 * \brief
 *  This Class Developed For Simulate a Dollar Wallet And Pay Energies.
 *  For Example Players Need to Move Very Fastly when they are in Dangerous Situation , So They Should to Buy Some Energies.
 */

#include <rcsc/player/player_agent.h>
#include <rcsc/player/player_state.h>
#include <vector>

//!Define Money
#define zero 0
#define one_Dollar 1
#define Five_Dollar 5
#define Ten_Dollar 10
#define Fifty_Dollar 50
#define Hundred_Dollar 100
//!Define Services
enum Energy_Type
{
    Extra  ,
    Major ,
    Good ,
    Minor ,
    Eco ,
    Normal ,
    E5 ,
    E10 ,
    E20 ,
    E25 ,
    E40 ,
    E45 ,
    E50 ,
    E55 ,
    E60 ,
    E65 ,
    E70 ,
    E75,
    E80 ,
    E85 ,
    E90 ,
    E95 ,
    E100
};
//! Define Bought Services
static std::vector<Energy_Type> My_Energy = { Extra  ,
                                             Major ,
                                             Good ,
                                             Minor ,
                                             Eco ,
                                             Normal ,
                                             E5 ,
                                             E10 ,
                                             E20 ,
                                             E25 ,
                                             E40 ,
                                             E45 ,
                                             E50 ,
                                             E55 ,
                                             E60 ,
                                             E65 ,
                                             E70 ,
                                             E75,
                                             E80 ,
                                             E85 ,
                                             E90 ,
                                             E95 ,
                                             E100 };
//!Define Wallet
static int Wallet = rcsc::ServerParam::i().staminaCapacity();

class EnergyStore {
public:
    EnergyStore(){ }
    void buy(Energy_Type energyType);
    void sell(Energy_Type energyType);
    int Get_Wallet(){ return Wallet; }
};


#endif //HELIOS_BASE_ENERGYSTORE_H
